import React from 'react';
export declare type ReactOnChangeType = React.ChangeEvent<HTMLInputElement> | React.ChangeEvent<HTMLTextAreaElement> | React.ChangeEvent<HTMLSelectElement>;
export declare type validFuncType = (_e: any) => string | null;
export declare type onChangeType = (_e: ReactOnChangeType) => void;
export declare type onChangeHandlerType = (_e: string) => void;
export declare type toValidType = (_e: string) => string | null;
declare type radioOptionType = {
    option: any;
};
declare type fieldBase = {
    error?: string;
    immediatelyValidate?: boolean;
    required?: boolean;
    toValid?: () => void;
    validations?: validFuncType[];
    minLen?: number;
    maxLen?: number;
    fieldProps?: object;
    [key: string]: unknown;
};
declare type inputFieldType = fieldBase & {
    type?: 'text' | 'password' | 'email' | 'range';
    value?: string;
    checked?: never;
};
declare type radioFieldType = fieldBase & {
    type: 'radio';
    value: string;
    checked?: boolean;
    options: radioOptionType[];
};
declare type checkboxFieldType = fieldBase & {
    type: 'checkbox';
    checked: boolean;
    value?: never;
};
export declare type formSchemaType = {
    [key: string]: checkboxFieldType | radioFieldType | inputFieldType;
};
export declare type formFields = {
    [key: string]: {
        fieldProps: {
            value: string;
            name: string;
            required?: boolean;
            onChange: onChangeType;
        };
        error?: string;
        toValid?: () => void;
        radioOptions?: any[];
    };
};
export declare type useFormType = {
    form: {
        fields: formFields;
        toJSON: () => {
            [key: string]: unknown;
        };
        toValidate: () => boolean;
    };
};
export {};
